﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ADOstudy
{
  public partial class Form1 : Form
  {
    private DataSet myData;
    private OleDbDataAdapter da;
    BindingSource bsParent;
    BindingSource bsChild;
    OleDbCommand cmd;
    OleDbParameterCollection pc;
    OleDbParameter p;

    public Form1()
    {
      InitializeComponent();
      myData = new DataSet();
      da = new OleDbDataAdapter();
      bsParent = new BindingSource();
      bsChild = new BindingSource();
    }

    private void Form1_Load(object sender, EventArgs e)
    {
      OleDbConnection connection = new OleDbConnection();
      connection.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=.\\AdoStudy.mdb";
      try
      {
        connection.Open();
      }
      catch
      {
        MessageBox.Show("Ошибка соединения с базой данных AdoStudy.mdb");
        Application.Exit();
      }
      cmd = connection.CreateCommand();
      cmd.CommandText = "SELECT *FROM Contacts";
      da.SelectCommand = cmd;
      da.FillSchema(myData, SchemaType.Source, "Contacts");
      da.Fill(myData, "Contacts");
      cmd.CommandText = "SELECT *FROM Phone";
      da.SelectCommand = cmd;
      da.FillSchema(myData, SchemaType.Source, "Phone");
      da.Fill(myData, "Phone");
      DataRelation rl = new DataRelation("relat", myData.Tables["Contacts"].Columns["idContact"],
                        myData.Tables["Phone"].Columns["idContact"], true);
      myData.Relations.Add(rl);
      bsParent.DataSource = myData;
      bsParent.DataMember = "Contacts";
      bsChild.DataSource = bsParent;
      bsChild.DataMember = "relat";
      dgvContacts.DataSource = bsParent;
      dgvPhone.DataSource = bsChild; 
      daInsert();
      daUpdate();
      daDelete();
     }

    private void testBaseBindingNavigatorSaveItem_Click(object sender, EventArgs e)
    {
       da.Update(myData.Tables["Contacts"]);
    }

    private void daInsert()
    {
      cmd.CommandText = "INSERT INTO Contacts " +
                        " (idContact, Person, Birthday, YearBirthday) VALUES " + 
                        " (@idContact, @Person, @Birthday, @YearBirthday)";
      da.InsertCommand = cmd;
      pc = da.InsertCommand.Parameters;
      pc.Add("@idContact", OleDbType.Integer, 0, "idContact");
      pc.Add("@Person", OleDbType.VarChar, 0, "Person");
      pc.Add("@Birthday", OleDbType.DBDate, 0, "Birthday");
      pc.Add("@YearBirthday", OleDbType.Integer, 0, "YearBirthday");
    }

    private void daUpdate()
    {
      cmd.CommandText = "UPDATE Contacts " +
                        " SET idContact = @idContact_New, Person = @Person_New, " + 
                        " Birthday = @Birthday_New, YearBirthday = @YearBirthday_New " + 
                        " WHERE idContact = @idContact_Old AND Person = @Person_Old AND " + 
                               " Birthday = @Birthday_Old AND YearBirthday = @YearBirthday_Old";
      da.UpdateCommand = cmd;
      pc = da.UpdateCommand.Parameters;
      pc.Add("@idContact_New", OleDbType.Integer, 0, "idContact");
      pc.Add("@Person_New", OleDbType.VarChar, 0, "Person");
      pc.Add("@Birthday_New", OleDbType.DBDate, 0, "Birthday");
      pc.Add("@YearBirthday_New", OleDbType.Integer, 0, "YearBirthday");
      p = pc.Add("@idContact_Old", OleDbType.Integer, 0, "idContact");
      p.SourceVersion = DataRowVersion.Original;
      p = pc.Add("@Person_Old", OleDbType.VarChar, 0, "Person");
      p.SourceVersion = DataRowVersion.Original;
      p = pc.Add("@Birthday_Old", OleDbType.DBDate, 0, "Birthday");
      p.SourceVersion = DataRowVersion.Original;
      p = pc.Add("@YearBirthday_Old", OleDbType.Integer, 0, "YearBirthday");
    }

    private void daDelete()
    {
      cmd.CommandText = "DELETE FROM Contacts " +
                        " WHERE idContact = @idContact AND Person = @Person AND " +
                               " Birthday = @Birthday AND YearBirthday = @YearBirthday";
      da.DeleteCommand = cmd;
      pc = da.DeleteCommand.Parameters;
      p = pc.Add("@idContact", OleDbType.Integer, 0, "idContact");
      p.SourceVersion = DataRowVersion.Original;
      p = pc.Add("@Person", OleDbType.VarChar, 0, "Person");
      p.SourceVersion = DataRowVersion.Original;
      p = pc.Add("@Birthday", OleDbType.DBDate, 0, "Birthday");
      p.SourceVersion = DataRowVersion.Original;
      p = pc.Add("@YearBirthday", OleDbType.Integer, 0, "YearBirthday");
      p.SourceVersion = DataRowVersion.Original;
    }
  }
}
